diff --git a/src/gui/painting/qdrawhelper.cpp b/src/gui/painting/qdrawhelper.cpp
index e46e997..76a5dfb 100644
--- a/src/gui/painting/qdrawhelper.cpp
+++ b/src/gui/painting/qdrawhelper.cpp
@@ -1307,6 +1480,14 @@ static void QT_FASTCALL destStore64RGB30(QRasterBuffer *rasterBuffer, int x, int
 #endif
 }
 
+static void QT_FASTCALL destStore64RGBA64(QRasterBuffer *rasterBuffer, int x, int y, const QRgba64 *buffer, int length)
+{
+    QRgba64 *dest = reinterpret_cast<QRgba64*>(rasterBuffer->scanLine(y)) + x;
+    for (int i = 0; i < length; ++i) {
+        dest[i] = buffer[i].unpremultiplied();
+    }
+}
+
 static DestStoreProc destStoreProc[QImage::NImageFormats] =
 {
     0,                  // Format_Invalid
@@ -1334,6 +1515,9 @@ static DestStoreProc destStoreProc[QImage::NImageFormats] =
     destStore,          // Format_A2RGB30_Premultiplied
     destStore,          // Format_Alpha8
     destStore,          // Format_Grayscale8
+    destStore,          // Format_RGBX64
+    destStore,          // Format_RGBA64
+    destStore,          // Format_RGBA64_Premultiplied
 };
 
 static DestStoreProc64 destStoreProc64[QImage::NImageFormats] =
@@ -1363,6 +1547,9 @@ static DestStoreProc64 destStoreProc64[QImage::NImageFormats] =
     destStore64RGB30<PixelOrderRGB>,        // Format_A2RGB30_Premultiplied
     destStore64,        // Format_Alpha8
     destStore64,        // Format_Grayscale8
+    0,                  // Format_RGBX64
+    destStore64RGBA64,  // Format_RGBA64
+    0                   // Format_RGBA64_Premultiplied
 };
 
 /*
@@ -1425,14 +1612,15 @@ static const QRgba64 *QT_FASTCALL fetchUntransformed64(QRgba64 *buffer, const Op
 {
     const QPixelLayout *layout = &qPixelLayouts[data->texture.format];
     const QRgb *clut = data->texture.colorTable ? data->texture.colorTable->constData() : 0;
-    if (layout->bpp != QPixelLayout::BPP32) {
-        uint buffer32[buffer_size];
-        const uint *ptr = qFetchPixels[layout->bpp](buffer32, data->texture.scanLine(y), x, length);
-        return layout->convertToARGB64PM(buffer, ptr, length, layout, clut);
-    } else {
-        const uint *src = (const uint *)data->texture.scanLine(y) + x;
-        return layout->convertToARGB64PM(buffer, src, length, layout, clut);
-    }
+    const quint64 *ptr = qFetchPixels64[layout->bpp](reinterpret_cast<quint64*>(buffer), data->texture.scanLine(y), x, length);
+    return layout->convertToRGBA64PM(buffer, ptr, length, layout, clut);
+}
+
+static const QRgba64 *QT_FASTCALL fetchUntransformedRGBA64PM(QRgba64 *, const Operator *,
+                                                             const QSpanData *data, int y, int x, int)
+{
+    const uchar *scanLine = data->texture.scanLine(y);
+    return ((const QRgba64 *)scanLine) + x;
 }
 
 // blendType is either BlendTransformed or BlendTransformedTiled
@@ -1613,10 +1801,9 @@ static const QRgba64 *QT_FASTCALL fetchTransformed64(QRgba64 *buffer, const Oper
     const qreal cy = y + qreal(0.5);
 
     const QPixelLayout *layout = &qPixelLayouts[data->texture.format];
-    FetchPixelFunc fetch = qFetchPixel[layout->bpp];
+    FetchPixelFunc64 fetch = qFetchPixel64[layout->bpp];
     const QRgb *clut = data->texture.colorTable ? data->texture.colorTable->constData() : 0;
 
-    uint buffer32[buffer_size];
     QRgba64 *b = buffer;
     if (data->fast_matrix) {
         // The increment pr x in the scanline
@@ -1631,7 +1818,7 @@ static const QRgba64 *QT_FASTCALL fetchTransformed64(QRgba64 *buffer, const Oper
         int i = 0,  j = 0;
         while (i < length) {
             if (j == buffer_size) {
-                layout->convertToARGB64PM(b, buffer32, buffer_size, layout, clut);
+                layout->convertToRGBA64PM(b, (const quint64*)b, buffer_size, layout, clut);
                 b += buffer_size;
                 j = 0;
             }
@@ -1647,14 +1834,14 @@ static const QRgba64 *QT_FASTCALL fetchTransformed64(QRgba64 *buffer, const Oper
                 px = qBound(0, px, image_width - 1);
                 py = qBound(0, py, image_height - 1);
             }
-            buffer32[j] = fetch(data->texture.scanLine(py), px);
+            b[j] = fetch(data->texture.scanLine(py), px);
 
             fx += fdx;
             fy += fdy;
             ++i; ++j;
         }
         if (j > 0) {
-            layout->convertToARGB64PM(b, buffer32, j, layout, clut);
+            layout->convertToRGBA64PM(b, (const quint64*)b, j, layout, clut);
             b += j;
         }
     } else {
@@ -1669,7 +1856,7 @@ static const QRgba64 *QT_FASTCALL fetchTransformed64(QRgba64 *buffer, const Oper
         int i = 0,  j = 0;
         while (i < length) {
             if (j == buffer_size) {
-                layout->convertToARGB64PM(b, buffer32, buffer_size, layout, clut);
+                layout->convertToRGBA64PM(b, (const quint64*)b, buffer_size, layout, clut);
                 b += buffer_size;
                 j = 0;
             }
@@ -1688,7 +1875,7 @@ static const QRgba64 *QT_FASTCALL fetchTransformed64(QRgba64 *buffer, const Oper
                 px = qBound(0, px, image_width - 1);
                 py = qBound(0, py, image_height - 1);
             }
-            buffer32[j] = fetch(data->texture.scanLine(py), px);
+            b[j] = fetch(data->texture.scanLine(py), px);
 
             fx += fdx;
             fy += fdy;
@@ -1700,7 +1887,7 @@ static const QRgba64 *QT_FASTCALL fetchTransformed64(QRgba64 *buffer, const Oper
             ++i; ++j;
         }
         if (j > 0) {
-            layout->convertToARGB64PM(b, buffer32, j, layout, clut);
+            layout->convertToRGBA64PM(b, (const quint64*)b, j, layout, clut);
             b += j;
         }
     }
@@ -1798,7 +1985,7 @@ static inline uint interpolate_4_pixels_16(uint tl, uint tr, uint bl, uint br, i
 #endif
 
 #if defined(__SSE2__)
-static inline QRgba64 interpolate_4_pixels_rgb64(QRgba64 t[], QRgba64 b[], uint distx, uint disty)
+static inline QRgba64 interpolate_4_pixels_rgb64(const QRgba64 t[], const QRgba64 b[], uint distx, uint disty)
 {
     const __m128i vdistx = _mm_shufflelo_epi16(_mm_cvtsi32_si128(distx), _MM_SHUFFLE(0, 0, 0, 0));
     const __m128i vidistx = _mm_shufflelo_epi16(_mm_cvtsi32_si128(0x10000 - distx), _MM_SHUFFLE(0, 0, 0, 0));
@@ -1821,7 +2008,7 @@ static inline QRgba64 interpolate_4_pixels_rgb64(QRgba64 t[], QRgba64 b[], uint
 #endif
 }
 #else
-static inline QRgba64 interpolate_4_pixels_rgb64(QRgba64 t[], QRgba64 b[], uint distx, uint disty)
+static inline QRgba64 interpolate_4_pixels_rgb64(const QRgba64 t[], const QRgba64 b[], uint distx, uint disty)
 {
     const uint dx = distx>>8;
     const uint dy = disty>>8;
@@ -2718,32 +2905,39 @@ static const uint *QT_FASTCALL fetchTransformedBilinear(uint *buffer, const Oper
     return buffer;
 }
 
-template<TextureBlendType blendType>
-static const QRgba64 *QT_FASTCALL fetchTransformedBilinear64(QRgba64 *buffer, const Operator *,
-                                                             const QSpanData *data, int y, int x, int length)
+template<TextureBlendType blendType, QPixelLayout::BPP BPP>
+static const QRgba64 *QT_FASTCALL fetchTransformedBilinear64_template(QRgba64 *buffer, const QSpanData *data,
+                                                                      int y, int x, int length)
 {
-    const QPixelLayout *layout = &qPixelLayouts[data->texture.format];
-    const QRgb *clut = data->texture.colorTable ? data->texture.colorTable->constData() : 0;
+    const QTextureData &texture = data->texture;
+    const QPixelLayout *layout = &qPixelLayouts[texture.format];
+    const QRgb *clut = texture.colorTable ? texture.colorTable->constData() : 0;
 
-    int image_width = data->texture.width;
-    int image_height = data->texture.height;
+    const int image_width = data->texture.width;
+    const int image_height = data->texture.height;
 
-    int image_x1 = data->texture.x1;
-    int image_y1 = data->texture.y1;
-    int image_x2 = data->texture.x2 - 1;
-    int image_y2 = data->texture.y2 - 1;
+    const int image_x1 = texture.x1;
+    const int image_y1 = texture.y1;
+    const int image_x2 = texture.x2 - 1;
+    const int image_y2 = texture.y2 - 1;
 
     const qreal cx = x + qreal(0.5);
     const qreal cy = y + qreal(0.5);
 
-    const qreal fdx = data->m11;
-    const qreal fdy = data->m12;
-    const qreal fdw = data->m13;
+    const FetchPixelFunc64 fetch = (BPP == QPixelLayout::BPPNone) ? qFetchPixel64[layout->bpp] : fetchPixel64<BPP>;
+
+    QRgba64 buf1[buffer_size];
+    QRgba64 buf2[buffer_size];
+    quint64 *sbuf1 = reinterpret_cast<quint64*>(buf1);
+    quint64 *sbuf2 = reinterpret_cast<quint64*>(buf2);
+
+    QRgba64 *end = buffer + length;
+    QRgba64 *b = buffer;
 
     if (data->fast_matrix) {
         // The increment pr x in the scanline
-        int fdx = (int)(data->m11 * fixed_scale);
-        int fdy = (int)(data->m12 * fixed_scale);
+        const int fdx = (int)(data->m11 * fixed_scale);
+        const int fdy = (int)(data->m12 * fixed_scale);
 
         int fx = int((data->m21 * cy + data->m11 * cx + data->dx) * fixed_scale);
         int fy = int((data->m22 * cy + data->m12 * cx + data->dy) * fixed_scale);
@@ -2755,16 +2949,10 @@ static const QRgba64 *QT_FASTCALL fetchTransformedBilinear64(QRgba64 *buffer, co
             int y1 = (fy >> 16);
             int y2;
             fetchTransformedBilinear_pixelBounds<blendType>(image_height, image_y1, image_y2, y1, y2);
-            const uchar *s1 = data->texture.scanLine(y1);
-            const uchar *s2 = data->texture.scanLine(y2);
+            const uchar *s1 = texture.scanLine(y1);
+            const uchar *s2 = texture.scanLine(y2);
 
-            FetchPixelFunc fetch = qFetchPixel[layout->bpp];
-            uint sbuf1[buffer_size];
-            uint sbuf2[buffer_size];
-            QRgba64 buf1[buffer_size];
-            QRgba64 buf2[buffer_size];
-            QRgba64 *b = buffer;
-            while (length) {
+            while (b < end) {
                 int len = qMin(length, buffer_size / 2);
                 int fracX = fx;
                 int i = 0;
@@ -2772,17 +2960,17 @@ static const QRgba64 *QT_FASTCALL fetchTransformedBilinear64(QRgba64 *buffer, co
 #if defined(__SSE2__)
                 const __m128i vdy = _mm_set1_epi16(disty);
                 const __m128i vidy = _mm_set1_epi16(0x10000 - disty);
-                if (blendType != BlendTransformedBilinearTiled && layout->bpp == QPixelLayout::BPP32) {
+                if (blendType != BlendTransformedBilinearTiled) {
                     for (; i < len; ++i) {
                         int x1 = (fx >> 16);
                         int x2;
                         fetchTransformedBilinear_pixelBounds<blendType>(image_width, image_x1, image_x2, x1, x2);
                         if (x1 != x2)
                             break;
-                        sbuf1[i * 2 + 0] = ((const uint*)s1)[x1];
-                        sbuf1[i * 2 + 1] = ((const uint*)s1)[x2];
-                        sbuf2[i * 2 + 0] = ((const uint*)s2)[x1];
-                        sbuf2[i * 2 + 1] = ((const uint*)s2)[x2];
+                        sbuf1[i * 2 + 0] = fetch(s1, x1);
+                        sbuf1[i * 2 + 1] = fetch(s1, x2);
+                        sbuf2[i * 2 + 0] = fetch(s2, x1);
+                        sbuf2[i * 2 + 1] = fetch(s2, x2);
                         fx += fdx;
                     }
 
@@ -2790,25 +2978,25 @@ static const QRgba64 *QT_FASTCALL fetchTransformedBilinear64(QRgba64 *buffer, co
                     __m128i v_fx = _mm_setr_epi32(fx, fx + fdx, fx + fdx + fdx, fx + fdx + fdx + fdx);
                     for (; i < len-3; i+=4) {
                         int offset = _mm_extract_epi16(v_fx, 1);
-                        sbuf1[i * 2 + 0] = ((const uint*)s1)[offset];
-                        sbuf1[i * 2 + 1] = ((const uint*)s1)[offset + 1];
-                        sbuf2[i * 2 + 0] = ((const uint*)s2)[offset];
-                        sbuf2[i * 2 + 1] = ((const uint*)s2)[offset + 1];
+                        sbuf1[i * 2 + 0] = fetch(s1, offset);
+                        sbuf1[i * 2 + 1] = fetch(s1, offset + 1);
+                        sbuf2[i * 2 + 0] = fetch(s2, offset);
+                        sbuf2[i * 2 + 1] = fetch(s2, offset + 1);
                         offset = _mm_extract_epi16(v_fx, 3);
-                        sbuf1[i * 2 + 2] = ((const uint*)s1)[offset];
-                        sbuf1[i * 2 + 3] = ((const uint*)s1)[offset + 1];
-                        sbuf2[i * 2 + 2] = ((const uint*)s2)[offset];
-                        sbuf2[i * 2 + 3] = ((const uint*)s2)[offset + 1];
+                        sbuf1[i * 2 + 2] = fetch(s1, offset);
+                        sbuf1[i * 2 + 3] = fetch(s1, offset + 1);
+                        sbuf2[i * 2 + 2] = fetch(s2, offset);
+                        sbuf2[i * 2 + 3] = fetch(s2, offset + 1);
                         offset = _mm_extract_epi16(v_fx, 5);
-                        sbuf1[i * 2 + 4] = ((const uint*)s1)[offset];
-                        sbuf1[i * 2 + 5] = ((const uint*)s1)[offset + 1];
-                        sbuf2[i * 2 + 4] = ((const uint*)s2)[offset];
-                        sbuf2[i * 2 + 5] = ((const uint*)s2)[offset + 1];
+                        sbuf1[i * 2 + 4] = fetch(s1, offset);
+                        sbuf1[i * 2 + 5] = fetch(s1, offset + 1);
+                        sbuf2[i * 2 + 4] = fetch(s2, offset);
+                        sbuf2[i * 2 + 5] = fetch(s2, offset + 1);
                         offset = _mm_extract_epi16(v_fx, 7);
-                        sbuf1[i * 2 + 6] = ((const uint*)s1)[offset];
-                        sbuf1[i * 2 + 7] = ((const uint*)s1)[offset + 1];
-                        sbuf2[i * 2 + 6] = ((const uint*)s2)[offset];
-                        sbuf2[i * 2 + 7] = ((const uint*)s2)[offset + 1];
+                        sbuf1[i * 2 + 6] = fetch(s1, offset);
+                        sbuf1[i * 2 + 7] = fetch(s1, offset + 1);
+                        sbuf2[i * 2 + 6] = fetch(s2, offset);
+                        sbuf2[i * 2 + 7] = fetch(s2, offset + 1);
                         v_fx = _mm_add_epi32(v_fx, v_fdx);
                     }
                     fx = _mm_cvtsi128_si32(v_fx);
@@ -2819,24 +3007,16 @@ static const QRgba64 *QT_FASTCALL fetchTransformedBilinear64(QRgba64 *buffer, co
                     int x2;
                     fetchTransformedBilinear_pixelBounds<blendType>(image_width, image_x1, image_x2, x1, x2);
 
-                    if (layout->bpp == QPixelLayout::BPP32) {
-                        sbuf1[i * 2 + 0] = ((const uint*)s1)[x1];
-                        sbuf1[i * 2 + 1] = ((const uint*)s1)[x2];
-                        sbuf2[i * 2 + 0] = ((const uint*)s2)[x1];
-                        sbuf2[i * 2 + 1] = ((const uint*)s2)[x2];
-
-                    } else {
-                        sbuf1[i * 2 + 0] = fetch(s1, x1);
-                        sbuf1[i * 2 + 1] = fetch(s1, x2);
-                        sbuf2[i * 2 + 0] = fetch(s2, x1);
-                        sbuf2[i * 2 + 1] = fetch(s2, x2);
-                    }
+                    sbuf1[i * 2 + 0] = fetch(s1, x1);
+                    sbuf1[i * 2 + 1] = fetch(s1, x2);
+                    sbuf2[i * 2 + 0] = fetch(s2, x1);
+                    sbuf2[i * 2 + 1] = fetch(s2, x2);
 
                     fx += fdx;
                 }
-                layout->convertToARGB64PM(buf1, sbuf1, len * 2, layout, clut);
+                layout->convertToRGBA64PM(buf1, sbuf1, len * 2, layout, clut);
                 if (disty)
-                    layout->convertToARGB64PM(buf2, sbuf2, len * 2, layout, clut);
+                    layout->convertToRGBA64PM(buf2, sbuf2, len * 2, layout, clut);
 
                 for (int i = 0; i < len; ++i) {
                     int distx = (fracX & 0x0000ffff);
@@ -2862,21 +3042,13 @@ static const QRgba64 *QT_FASTCALL fetchTransformedBilinear64(QRgba64 *buffer, co
                 b += len;
             }
         } else { //rotation
-            FetchPixelFunc fetch = qFetchPixel[layout->bpp];
-            uint sbuf1[buffer_size];
-            uint sbuf2[buffer_size];
-            QRgba64 buf1[buffer_size];
-            QRgba64 buf2[buffer_size];
-            QRgba64 *end = buffer + length;
-            QRgba64 *b = buffer;
-
             while (b < end) {
                 int len = qMin(length, buffer_size / 2);
                 int fracX = fx;
                 int fracY = fy;
                 int i = 0;
 #if defined(__SSE2__)
-                if (blendType != BlendTransformedBilinearTiled && layout->bpp == QPixelLayout::BPP32) {
+                if (blendType != BlendTransformedBilinearTiled && BPP >= QPixelLayout::BPP32) {
                     for (; i < len; ++i) {
                         int x1 = (fx >> 16);
                         int x2;
@@ -2886,12 +3058,12 @@ static const QRgba64 *QT_FASTCALL fetchTransformedBilinear64(QRgba64 *buffer, co
                         fetchTransformedBilinear_pixelBounds<blendType>(image_height, image_y1, image_y2, y1, y2);
                         if (x1 != x2 && y1 != y2)
                             break;
-                        const uchar *s1 = data->texture.scanLine(y1);
-                        const uchar *s2 = data->texture.scanLine(y2);
-                        sbuf1[i * 2 + 0] = ((const uint*)s1)[x1];
-                        sbuf1[i * 2 + 1] = ((const uint*)s1)[x2];
-                        sbuf2[i * 2 + 0] = ((const uint*)s2)[x1];
-                        sbuf2[i * 2 + 1] = ((const uint*)s2)[x2];
+                        const uchar *s1 = texture.scanLine(y1);
+                        const uchar *s2 = texture.scanLine(y2);
+                        sbuf1[i * 2 + 0] = fetch(s1, x1);
+                        sbuf1[i * 2 + 1] = fetch(s1, x2);
+                        sbuf2[i * 2 + 0] = fetch(s2, x1);
+                        sbuf2[i * 2 + 1] = fetch(s2, x2);
                         fx += fdx;
                         fy += fdy;
                     }
@@ -2900,10 +3072,11 @@ static const QRgba64 *QT_FASTCALL fetchTransformedBilinear64(QRgba64 *buffer, co
                     const __m128i v_fdy = _mm_set1_epi32(fdy*4);
                     __m128i v_fx = _mm_setr_epi32(fx, fx + fdx, fx + fdx + fdx, fx + fdx + fdx + fdx);
                     __m128i v_fy = _mm_setr_epi32(fy, fy + fdy, fy + fdy + fdy, fy + fdy + fdy + fdy);
-                    const int bytesPerLine = data->texture.bytesPerLine;
-                    const uchar *s1 = data->texture.imageData;
+                    const int bytesPerLine = texture.bytesPerLine;
+                    const uchar *s1 = texture.imageData;
                     const uchar *s2 = s1 + bytesPerLine;
-                    const __m128i vbpl = _mm_shufflelo_epi16(_mm_cvtsi32_si128(bytesPerLine/4), _MM_SHUFFLE(0, 0, 0, 0));
+                    const int pbl = BPP == QPixelLayout::BPP32 ? bytesPerLine/4 : bytesPerLine/8;
+                    const __m128i vbpl = _mm_shufflelo_epi16(_mm_cvtsi32_si128(pbl), _MM_SHUFFLE(0, 0, 0, 0));
                     for (; i < len-3; i+=4) {
                         if (fdx > 0 && (short)_mm_extract_epi16(v_fx, 7) >= image_x2)
                             break;
@@ -2918,26 +3091,25 @@ static const QRgba64 *QT_FASTCALL fetchTransformedBilinear64(QRgba64 *buffer, co
                         voffset = _mm_add_epi32(voffset, _mm_srli_epi32(v_fx, 16));
 
                         int offset = _mm_cvtsi128_si32(voffset); voffset = _mm_srli_si128(voffset, 4);
-                        sbuf1[i * 2 + 0] = ((const uint*)s1)[offset];
-                        sbuf1[i * 2 + 1] = ((const uint*)s1)[offset + 1];
-                        sbuf2[i * 2 + 0] = ((const uint*)s2)[offset];
-                        sbuf2[i * 2 + 1] = ((const uint*)s2)[offset + 1];
+                        sbuf1[i * 2 + 0] = fetch(s1, offset);
+                        sbuf1[i * 2 + 1] = fetch(s1, offset + 1);
+                        sbuf2[i * 2 + 0] = fetch(s2, offset);
+                        sbuf2[i * 2 + 1] = fetch(s2, offset + 1);
                         offset = _mm_cvtsi128_si32(voffset); voffset = _mm_srli_si128(voffset, 4);
-                        sbuf1[i * 2 + 2] = ((const uint*)s1)[offset];
-                        sbuf1[i * 2 + 3] = ((const uint*)s1)[offset + 1];
-                        sbuf2[i * 2 + 2] = ((const uint*)s2)[offset];
-                        sbuf2[i * 2 + 3] = ((const uint*)s2)[offset + 1];
+                        sbuf1[i * 2 + 2] = fetch(s1, offset);
+                        sbuf1[i * 2 + 3] = fetch(s1, offset + 1);
+                        sbuf2[i * 2 + 2] = fetch(s2, offset);
+                        sbuf2[i * 2 + 3] = fetch(s2, offset + 1);
                         offset = _mm_cvtsi128_si32(voffset); voffset = _mm_srli_si128(voffset, 4);
-                        sbuf1[i * 2 + 4] = ((const uint*)s1)[offset];
-                        sbuf1[i * 2 + 5] = ((const uint*)s1)[offset + 1];
-                        sbuf2[i * 2 + 4] = ((const uint*)s2)[offset];
-                        sbuf2[i * 2 + 5] = ((const uint*)s2)[offset + 1];
+                        sbuf1[i * 2 + 4] = fetch(s1, offset);
+                        sbuf1[i * 2 + 5] = fetch(s1, offset + 1);
+                        sbuf2[i * 2 + 4] = fetch(s2, offset);
+                        sbuf2[i * 2 + 5] = fetch(s2, offset + 1);
                         offset = _mm_cvtsi128_si32(voffset);
-                        sbuf1[i * 2 + 6] = ((const uint*)s1)[offset];
-                        sbuf1[i * 2 + 7] = ((const uint*)s1)[offset + 1];
-                        sbuf2[i * 2 + 6] = ((const uint*)s2)[offset];
-                        sbuf2[i * 2 + 7] = ((const uint*)s2)[offset + 1];
-
+                        sbuf1[i * 2 + 6] = fetch(s1, offset);
+                        sbuf1[i * 2 + 7] = fetch(s1, offset + 1);
+                        sbuf2[i * 2 + 6] = fetch(s2, offset);
+                        sbuf2[i * 2 + 7] = fetch(s2, offset + 1);
                         v_fx = _mm_add_epi32(v_fx, v_fdx);
                         v_fy = _mm_add_epi32(v_fy, v_fdy);
                     }
@@ -2953,27 +3125,19 @@ static const QRgba64 *QT_FASTCALL fetchTransformedBilinear64(QRgba64 *buffer, co
                     fetchTransformedBilinear_pixelBounds<blendType>(image_width, image_x1, image_x2, x1, x2);
                     fetchTransformedBilinear_pixelBounds<blendType>(image_height, image_y1, image_y2, y1, y2);
 
-                    const uchar *s1 = data->texture.scanLine(y1);
-                    const uchar *s2 = data->texture.scanLine(y2);
+                    const uchar *s1 = texture.scanLine(y1);
+                    const uchar *s2 = texture.scanLine(y2);
 
-                    if (layout->bpp == QPixelLayout::BPP32) {
-                        sbuf1[i * 2 + 0] = ((const uint*)s1)[x1];
-                        sbuf1[i * 2 + 1] = ((const uint*)s1)[x2];
-                        sbuf2[i * 2 + 0] = ((const uint*)s2)[x1];
-                        sbuf2[i * 2 + 1] = ((const uint*)s2)[x2];
-
-                    } else {
-                        sbuf1[i * 2 + 0] = fetch(s1, x1);
-                        sbuf1[i * 2 + 1] = fetch(s1, x2);
-                        sbuf2[i * 2 + 0] = fetch(s2, x1);
-                        sbuf2[i * 2 + 1] = fetch(s2, x2);
-                    }
+                    sbuf1[i * 2 + 0] = fetch(s1, x1);
+                    sbuf1[i * 2 + 1] = fetch(s1, x2);
+                    sbuf2[i * 2 + 0] = fetch(s2, x1);
+                    sbuf2[i * 2 + 1] = fetch(s2, x2);
 
                     fx += fdx;
                     fy += fdy;
                 }
-                layout->convertToARGB64PM(buf1, sbuf1, len * 2, layout, clut);
-                layout->convertToARGB64PM(buf2, sbuf2, len * 2, layout, clut);
+                layout->convertToRGBA64PM(buf1, sbuf1, len * 2, layout, clut);
+                layout->convertToRGBA64PM(buf2, sbuf2, len * 2, layout, clut);
 
                 for (int i = 0; i < len; ++i) {
                     int distx = (fracX & 0x0000ffff);
@@ -2987,22 +3151,18 @@ static const QRgba64 *QT_FASTCALL fetchTransformedBilinear64(QRgba64 *buffer, co
                 b += len;
             }
         }
-    } else {
+    } else { // !(data->fast_matrix)
+        const qreal fdx = data->m11;
+        const qreal fdy = data->m12;
+        const qreal fdw = data->m13;
         qreal fx = data->m21 * cy + data->m11 * cx + data->dx;
         qreal fy = data->m22 * cy + data->m12 * cx + data->dy;
         qreal fw = data->m23 * cy + data->m13 * cx + data->m33;
 
-        FetchPixelFunc fetch = qFetchPixel[layout->bpp];
-        uint sbuf1[buffer_size];
-        uint sbuf2[buffer_size];
-        QRgba64 buf1[buffer_size];
-        QRgba64 buf2[buffer_size];
-        QRgba64 *b = buffer;
-
         int distxs[buffer_size / 2];
         int distys[buffer_size / 2];
 
-        while (length) {
+        while (b < end) {
             int len = qMin(length, buffer_size / 2);
             for (int i = 0; i < len; ++i) {
                 const qreal iw = fw == 0 ? 1 : 1 / fw;
@@ -3020,21 +3180,13 @@ static const QRgba64 *QT_FASTCALL fetchTransformedBilinear64(QRgba64 *buffer, co
                 fetchTransformedBilinear_pixelBounds<blendType>(image_width, image_x1, image_x2, x1, x2);
                 fetchTransformedBilinear_pixelBounds<blendType>(image_height, image_y1, image_y2, y1, y2);
 
-                const uchar *s1 = data->texture.scanLine(y1);
-                const uchar *s2 = data->texture.scanLine(y2);
+                const uchar *s1 = texture.scanLine(y1);
+                const uchar *s2 = texture.scanLine(y2);
 
-                if (layout->bpp == QPixelLayout::BPP32) {
-                    sbuf1[i * 2 + 0] = ((const uint*)s1)[x1];
-                    sbuf1[i * 2 + 1] = ((const uint*)s1)[x2];
-                    sbuf2[i * 2 + 0] = ((const uint*)s2)[x1];
-                    sbuf2[i * 2 + 1] = ((const uint*)s2)[x2];
-
-                } else {
-                    sbuf1[i * 2 + 0] = fetch(s1, x1);
-                    sbuf1[i * 2 + 1] = fetch(s1, x2);
-                    sbuf2[i * 2 + 0] = fetch(s2, x1);
-                    sbuf2[i * 2 + 1] = fetch(s2, x2);
-                }
+                sbuf1[i * 2 + 0] = fetch(s1, x1);
+                sbuf1[i * 2 + 1] = fetch(s1, x2);
+                sbuf2[i * 2 + 0] = fetch(s2, x1);
+                sbuf2[i * 2 + 1] = fetch(s2, x2);
 
                 fx += fdx;
                 fy += fdy;
@@ -3044,8 +3196,8 @@ static const QRgba64 *QT_FASTCALL fetchTransformedBilinear64(QRgba64 *buffer, co
                     fw += fdw;
             }
 
-            layout->convertToARGB64PM(buf1, sbuf1, len * 2, layout, clut);
-            layout->convertToARGB64PM(buf2, sbuf2, len * 2, layout, clut);
+            layout->convertToRGBA64PM(buf1, sbuf1, len * 2, layout, clut);
+            layout->convertToRGBA64PM(buf2, sbuf2, len * 2, layout, clut);
 
             for (int i = 0; i < len; ++i) {
                 int distx = distxs[i];
@@ -3057,10 +3209,26 @@ static const QRgba64 *QT_FASTCALL fetchTransformedBilinear64(QRgba64 *buffer, co
             b += len;
         }
     }
-
     return buffer;
 }
 
+template<TextureBlendType blendType>
+static const QRgba64 *QT_FASTCALL fetchTransformedBilinear64(QRgba64 *buffer, const Operator *,
+                                                             const QSpanData *data, int y, int x, int length)
+{
+    // This trick makes it possible for the compiler to inline fetchPixel
+    switch (qPixelLayouts[data->texture.format].bpp) {
+    case QPixelLayout::BPP32:
+        return fetchTransformedBilinear64_template<blendType, QPixelLayout::BPP32>(buffer, data, y, x, length);
+    case QPixelLayout::BPP64:
+        return fetchTransformedBilinear64_template<blendType, QPixelLayout::BPP64>(buffer, data, y, x, length);
+    default:
+        break;
+    }
+    // Use a generic fallback so we don't generate too many specialized versions.
+    return fetchTransformedBilinear64_template<blendType, QPixelLayout::BPPNone>(buffer, data, y, x, length);
+}
+
 static SourceFetchProc sourceFetch[NBlendTypes][QImage::NImageFormats] = {
     // Untransformed
     {
@@ -3089,6 +3257,9 @@ static SourceFetchProc sourceFetch[NBlendTypes][QImage::NImageFormats] = {
         fetchUntransformed,         // Format_A2RGB30_Premultiplied
         fetchUntransformed,         // Alpha8
         fetchUntransformed,         // Grayscale8
+        fetchUntransformed,
+        fetchUntransformed,
+        fetchUntransformed,
     },
     // Tiled
     {
@@ -3117,6 +3288,9 @@ static SourceFetchProc sourceFetch[NBlendTypes][QImage::NImageFormats] = {
         fetchUntransformed,         // A2RGB30_Premultiplied
         fetchUntransformed,         // Alpha8
         fetchUntransformed,         // Grayscale8
+        fetchUntransformed,
+        fetchUntransformed,
+        fetchUntransformed,
     },
     // Transformed
     {
@@ -3145,6 +3319,9 @@ static SourceFetchProc sourceFetch[NBlendTypes][QImage::NImageFormats] = {
         fetchTransformed<BlendTransformed>,         // A2RGB30_Premultiplied
         fetchTransformed<BlendTransformed>,         // Alpah8
         fetchTransformed<BlendTransformed>,         // Grayscale8
+        fetchTransformed<BlendTransformed>,         // RGBX64
+        fetchTransformed<BlendTransformed>,         // RGBA64
+        fetchTransformed<BlendTransformed>,         // RGBA64_Premultiplied
     },
     {
         0, // TransformedTiled
@@ -3172,6 +3349,9 @@ static SourceFetchProc sourceFetch[NBlendTypes][QImage::NImageFormats] = {
         fetchTransformed<BlendTransformedTiled>,            // A2RGB30_Premultiplied
         fetchTransformed<BlendTransformedTiled>,            // Alpha8
         fetchTransformed<BlendTransformedTiled>,            // Grayscale8
+        fetchTransformed<BlendTransformedTiled>,            // RGBX64
+        fetchTransformed<BlendTransformedTiled>,            // RGBA64
+        fetchTransformed<BlendTransformedTiled>,            // RGBA64_Premultiplied
     },
     {
         0, // Bilinear
@@ -3199,6 +3379,9 @@ static SourceFetchProc sourceFetch[NBlendTypes][QImage::NImageFormats] = {
         fetchTransformedBilinear<BlendTransformedBilinear>,         // A2RGB30_Premultiplied
         fetchTransformedBilinear<BlendTransformedBilinear>,         // Alpha8
         fetchTransformedBilinear<BlendTransformedBilinear>,         // Grayscale8
+        fetchTransformedBilinear<BlendTransformedBilinear>,         // RGBX64
+        fetchTransformedBilinear<BlendTransformedBilinear>,         // RGBA64
+        fetchTransformedBilinear<BlendTransformedBilinear>,         // RGBA64_Premultiplied
     },
     {
         0, // BilinearTiled
@@ -3226,6 +3409,9 @@ static SourceFetchProc sourceFetch[NBlendTypes][QImage::NImageFormats] = {
         fetchTransformedBilinear<BlendTransformedBilinearTiled>,            // A2RGB30_Premultiplied
         fetchTransformedBilinear<BlendTransformedBilinearTiled>,            // Alpha8
         fetchTransformedBilinear<BlendTransformedBilinearTiled>,            // Grayscale8
+        fetchTransformedBilinear<BlendTransformedBilinearTiled>,            // RGBX64
+        fetchTransformedBilinear<BlendTransformedBilinearTiled>,            // RGBA64
+        fetchTransformedBilinear<BlendTransformedBilinearTiled>,            // RGBA64_Premultiplied
     },
 };
 
@@ -3257,6 +3443,9 @@ static SourceFetchProc64 sourceFetch64[NBlendTypes][QImage::NImageFormats] = {
         fetchUntransformed64,         // Format_A2RGB30_Premultiplied
         fetchUntransformed64,         // Alpha8
         fetchUntransformed64,         // Grayscale8
+        fetchUntransformedRGBA64PM,   // RGBX64
+        fetchUntransformed64,         // RGBA64
+        fetchUntransformedRGBA64PM,   // RGBA64_Premultiplied
     },
     // Tiled
     {
